# Modeling

The SDV creates synthetic data using machine learning. A **synthesizer** is an object that you can use to accomplish this task.

1. You'll start by creating a synthesizer based on your metadata
2. Next, you'll train the synthesizer using real data. In this phase, the synthesizer will learn patterns from the real data.
3. Once your synthesizer is trained, you can use it to generate new, synthetic data.

```python
from sdv.single_table import GaussianCopulaSynthesizer

# Step 1: Create the synthesizer
synthesizer = GaussianCopulaSynthesizer(metadata)

# Step 2: Train the synthesizer
synthesizer.fit(real_data)

# Step 3: Generate synthetic data
synthetic_data = synthesizer.sample(num_rows=100)
```

## What's next?

[**Choose from a variety of synthesizers.**](https://docs.sdv.dev/sdv/single-table-data/modeling/synthesizers) Each synthesizer uses a different machine learning technique for training.

**Want to improve your synthetic data?** You can control the pre- and post-processing steps in your synthesizer, and set up custom, anonymization controls. You can also enforce logical rules in the form of constraints. See the [**Advanced Features**](https://docs.sdv.dev/sdv/single-table-data/modeling/customizations) for more options.&#x20;


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.sdv.dev/sdv/single-table-data/modeling.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
